"""initial setup

Revision ID: 95e4686853fd
Revises: 
Create Date: 2021-05-12 06:37:57.181449

"""
from alembic import op
import sqlalchemy as sa
import adf.services.database.custom_types


# revision identifiers, used by Alembic.
revision = '95e4686853fd'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('business_units',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('country', sa.String(), nullable=False),
    sa.Column('division', sa.String(), nullable=False),
    sa.Column('sales_org_cod', sa.String(), nullable=False),
    sa.Column('uom', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('country', 'division', 'sales_org_cod')
    )
    op.create_table('pipeline_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('algorithm_type', sa.String(), nullable=False),
    sa.Column('run_type', sa.String(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('plc_api_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('country', sa.String(), nullable=False),
    sa.Column('division', sa.String(), nullable=False),
    sa.Column('type', sa.String(), nullable=False),
    sa.Column('date', sa.Date(), nullable=False),
    sa.Column('status', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('country', 'division', 'type', 'date')
    )
    op.create_table('weather_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('country', sa.String(), nullable=False),
    sa.Column('division', sa.String(), nullable=False),
    sa.Column('type', sa.String(), nullable=False),
    sa.Column('date', sa.Date(), nullable=False),
    sa.Column('rows', sa.Integer(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('country', 'division', 'type', 'date')
    )
    op.create_table('data_sources',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('business_unit_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('source', sa.String(), nullable=False),
    sa.Column('parser', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.Column('unique', sa.Boolean(), nullable=False),
    sa.Column('landing_mount', sa.String(), nullable=False),
    sa.Column('landing_folder', sa.String(), nullable=False),
    sa.Column('landing_file_prefix', sa.String(), nullable=False),
    sa.Column('update_frequency', sa.String(), nullable=False),
    sa.Column('time_column', sa.String(), nullable=True),
    sa.Column('business_critical', sa.Boolean(), nullable=False),
    sa.Column('split', adf.services.database.custom_types.CustomJSON(), nullable=True),
    sa.ForeignKeyConstraint(['business_unit_id'], ['business_units.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('business_unit_id', 'source')
    )
    op.create_table('dataprep_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('business_unit_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('product_level', sa.String(), nullable=False),
    sa.Column('location_level', sa.String(), nullable=False),
    sa.Column('scope', sa.String(), nullable=False),
    sa.Column('split_type', sa.String(), nullable=True),
    sa.Column('split_code', sa.Integer(), nullable=True),
    sa.Column('prep_type', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['business_unit_id'], ['business_units.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('ibp_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('business_unit_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('description', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.ForeignKeyConstraint(['business_unit_id'], ['business_units.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('preprocessing_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('description', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('streamlit_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('input_mount', sa.String(), nullable=False),
    sa.Column('input_blob', sa.String(), nullable=False),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('description', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('building_blocks_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('business_unit_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('dataprep_report_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('scope', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['business_unit_id'], ['business_units.id'], ),
    sa.ForeignKeyConstraint(['dataprep_report_id'], ['dataprep_reports.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('etl_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('data_source_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('date', sa.Date(), nullable=False),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('version', sa.Integer(), nullable=False),
    sa.Column('extension', sa.String(), nullable=False),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('latest_provision', sa.String(), nullable=True),
    sa.Column('overrides_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.ForeignKeyConstraint(['data_source_id'], ['data_sources.id'], ),
    sa.ForeignKeyConstraint(['overrides_id'], ['etl_reports.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('data_source_id', 'date', 'version')
    )
    op.create_table('split_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('data_source_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('split_file', sa.String(), nullable=True),
    sa.Column('new_files', sa.ARRAY(sa.String()), nullable=True),
    sa.Column('outputs_number', sa.Integer(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.ForeignKeyConstraint(['data_source_id'], ['data_sources.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('training_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('preprocessing_report_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('description', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('training_type', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.ForeignKeyConstraint(['preprocessing_report_id'], ['preprocessing_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('data_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('etl_report_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['etl_report_id'], ['etl_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('forecast_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('training_report_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('input_mount', sa.String(), nullable=False),
    sa.Column('input_blob', sa.String(), nullable=False),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('description', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('training_type', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.ForeignKeyConstraint(['training_report_id'], ['training_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('metrics_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('etl_report_id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('country', sa.String(), nullable=False),
    sa.Column('division', sa.String(), nullable=False),
    sa.Column('source', sa.String(), nullable=False),
    sa.Column('version', sa.Integer(), nullable=False),
    sa.Column('date', sa.Date(), nullable=False),
    sa.Column('item', sa.String(), nullable=False),
    sa.Column('metric', sa.String(), nullable=False),
    sa.Column('metric_value', sa.Float(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['etl_report_id'], ['etl_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('metrics_reports')
    op.drop_table('forecast_reports')
    op.drop_table('data_reports')
    op.drop_table('training_reports')
    op.drop_table('split_reports')
    op.drop_table('etl_reports')
    op.drop_table('building_blocks_reports')
    op.drop_table('streamlit_reports')
    op.drop_table('preprocessing_reports')
    op.drop_table('ibp_reports')
    op.drop_table('dataprep_reports')
    op.drop_table('data_sources')
    op.drop_table('weather_reports')
    op.drop_table('plc_api_reports')
    op.drop_table('pipeline_reports')
    op.drop_table('business_units')
    # ### end Alembic commands ###
